newton := proc (f::list, v::list, _a::list, k::integer, max::integer)
#print(eval(f));
  
  local a,t,j,i,n,size;

  a := _a;
  t := f;
  
  size := nops(f);  #Number of items in list

  if ((size <> nops(v)) or (size <> nops(a))) then
    print("Invalid size of parameters.");
    return;
  fi;

  for i from 1 to max do
      t := f;               #we need original f every time
      j := jacobian(f,v);                #calculate jacobian
      for n from 1 to size do            #replace variables
          j:=subs(v[n]=a[n],evalm(j));
          t:=subs(v[n]=a[n],evalm(t));
      od;

      if (simplify(norm(t,2))<10^(-k)) then  #Check for desired precision
         print(i);
         return(evalm(a));
      fi;

      if det(j)=0 then                   #check if inverse exists
         print("Jacobian doesn't have inverse.  Cannot continue.");
         return evalm(a);
      fi;

      a := evalm(a - inverse(j)&*evalm(t));
  od;
  evalm(a);
 
end:






























